-- freely inspired by MountMe
-- http://www.wowinterface.com/downloads/info19197-MountMe.html

-- thanks to SDPhantom for hints and code fix
-- http://www.wowinterface.com/forums/member.php?u=34145

-- it can used in a macro like: 
-- /mrc [btn:2] category2; [swimming] category3; [mod:shift] category4; [mod:alt] favorites!; all! 

-- if categories.lua was not found
MyCatMount_mrc = {}

local prgname = "|cffffd200mntrndcat|r"
local table_insert = table.insert

SLASH_MOUNTRNDCAT1 = "/mntrndcat"
SLASH_MOUNTRNDCAT2 = "/mrc"
SlashCmdList["MOUNTRNDCAT"] = function(args) 
	local category=SecureCmdOptionParse(args)
	category=category:lower()
	
	if category=="" then
		print(prgname .. ":")
		print("/mrc  - This help")
		print("/mrc category - Summon a random mount from your 'category' list")
		print("/mrc favorites! - Summon a random mount from your favorite list")
		print("/mrc all! - Summon a random mount")
		return
		
	elseif category == "all!" then 
		
		local AllMounts={}
		for index=1,C_MountJournal.GetNumMounts() do
			local _, _, _, isActive, summonable, _ = C_MountJournal.GetMountInfo(index)
			if  summonable == true and isActive == false then
				table_insert(AllMounts, index)
			end
		end	
		
		if #AllMounts == 0 then 
				print(prgname .. " no valid mounts found to summon" )
				return
		end		
		
		local number=random(1,#AllMounts)
		local name, _ = C_MountJournal.GetMountInfo(AllMounts[number])
		C_MountJournal.Summon(AllMounts[number])
		print(prgname .. " is summoning... " .. name)
		AllMounts={}
	
	elseif category=="favorites!" then

		local FavoriteMounts={}
		for index=1,C_MountJournal.GetNumMounts() do
			local _, _, _, isActive, summonable, _, isFavorite, _ = C_MountJournal.GetMountInfo(index)
			if  isFavorite == true and summonable == true and isActive == false then
				table_insert(FavoriteMounts, index)
			end
		end	
		
		if #FavoriteMounts == 0 then 
				print(prgname .. " no valid or different mount found in favorites category" )
				return
		end

		if IsMounted() then Dismount() end
		
		local number=random(1,#FavoriteMounts)
		local name, _ = C_MountJournal.GetMountInfo(FavoriteMounts[number])
		C_MountJournal.Summon(FavoriteMounts[number])
		print(prgname .. " is summoning... " .. name)
		FavoriteMounts={}
		
	elseif MyCatMount_mrc[category] then

		local msg=prgname .. " error: unable to summon "
		local CategoryMounts={}
		for i=1,#MyCatMount_mrc[category] do
			local picked=MyCatMount_mrc[category][i]:lower()
			for index=1,C_MountJournal.GetNumMounts() do
				local name, _, _, isActive, summonable, _ = C_MountJournal.GetMountInfo(index)				
				if  name:lower()==picked and summonable == true and isActive == false then
					table_insert(CategoryMounts, index)
				end
			end
		end
				
		if #CategoryMounts == 0 then 
				print(prgname .. " no valid mounts found in custom category " .. category)
				return
		end
		
		if IsMounted() then Dismount() end
		
		local number=random(1,#CategoryMounts)
		local picked=CategoryMounts[number]
		
		for index=1,C_MountJournal.GetNumMounts() do
			local name, _ = C_MountJournal.GetMountInfo(index)
			if index==picked then
				msg = prgname .. " is summoning... " .. name
				C_MountJournal.Summon(index)
				break
			end
		end
		print(msg)
		CategoryMounts={}		
	
		
	else
	
		print(prgname .. " error: unable to find category " .. category .. " or categories.lua is missing")		
	
	end
end